#!/bin/sh

#configuration variables variables
dir_of_arm_toolchain=/usr/local/arm-2007q1/bin/
arm_toolchain=arm-none-linux-gnueabi-gcc

bin_name=ro-eth-custom
list_of_files="./source/main.c
               ./library/vc/deditec_string_utils.c
               ./library/vc/deditec_parameter_io.c
               ./library/vc/deditec_msgqueue.c
               ./library/vc/deditec_log.c
               ./delib-linux/delib-sources/delib/delib_Dapi_di_do_ad_da_befehle-eth.c
               ./delib-linux/delib-sources/delib/delib_set_get_error.c
               ./delib-linux/delib-sources/delib/delib_Dapi_register_commands-eth.c
               ./delib-linux/delib-sources/delib/delib_open_close_linux-eth.c
               ./delib-linux/delib-sources/delib/delib_open_close-eth.c
               ./delib-linux/delib-sources/delib/delib_io_tcp.c
               ./library/vc/deditec_tcp_functions.c
               ./library/vc/deditec_tcp_io.c
 -g"

arm_bin_rights=710
pc_bin_rights=710

arm_bin_dest="/nfs/rootfs_ecpu800/deditec/custom1/bin"
#pc_bin_dest="./"

compile_error=100
change_rights_error=70

if [ "$1" = "" ] # script was called without arguments
   then
      echo compiling for arm
      $dir_of_arm_toolchain$arm_toolchain -o $bin_name $list_of_files
      if [ "$?" != "0" ]
         then echo
              echo "error(s) found while compiling"
              exit $compile_error
         else echo
              echo "compiling successfull"
      fi
      echo changing rights
      chmod $arm_bin_rights $bin_name
      if [ "$?" != "0" ]
         then echo "error while changing rights: chmod $arm_bin_rights $bin_name"
         exit $change_rights_error
      fi
      echo copy $bin_name to $arm_bin_dest
      cp ./$bin_name $arm_bin_dest


   else if [ "$1" = "arm" ]
        then echo compiling for arm cpu calling \'$arm_toolchain\' at \'$dir_of_arm_toolchain\'
              # compiling for arm cpu and copying files to directory
              echo
              $dir_of_arm_toolchain$arm_toolchain -o $bin_name $list_of_files 
    
              if [ "$?" != "0" ]
                    then echo
                        echo "error(s) found while compiling"
                        exit $compile_error
                    else echo
                        echo "compiling successfull"
              fi
              echo changing rights
              chmod $arm_bin_rights $bin_name
              if [ "$?" != "0" ]
                then echo "error while changing rights: chmod $arm_bin_rights $bin_name"
                exit $change_rights_error
              fi
              echo copy $bin_name to $arm_bin_dest
              cp ./$bin_name $arm_bin_dest


          else if [ "$1" = "pc" ]
               then echo compiling for i386 cpu calling gcc -o server $list_of_files
               #\'gcc -o server server2.c tcp_io.c deditec_string_utils.c  deditec_tcp_functions.c deditec_tcp_execute.c -g\'
                  # compiling for pc and copying files to directory
                  echo
                  gcc -o $bin_name $list_of_files

                  if [ "$?" != "0" ]
                      then echo
                          echo "error(s) found while compiling"
                          exit $compile_error
                      else echo
                          echo "compiling successfull"
                  fi
                  echo changing rights
                  chmod $pc_bin_rights $bin_name
                  if [ "$?" != "0" ]
                      then echo "error while changing rights: chmod $pc_bin_rights $bin_name"
                      exit $change_rights_error
                  fi
                  #echo copy $bin_name to $arm_bin_dest

                  else echo bad argument, nothing done, use \'arm\' or \'pc\' as argument to compile
               fi
          fi
fi
