#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "deditec_log.h"
#include "dt_embedded_parameter.h"


unsigned char global_name[200];
unsigned long global_screen_output_enable;


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////////////////////////////////
// writes given string (ex. POST or stdout of an executed command) to log file
// Date and time is automatically prepended
//
// returns values:
//
//  none
//////////////////////////////////////////////////////////////////////////////////////////////////

void log_write(unsigned char * log_text_original, unsigned long screen_output_enable) // output == 1 --> to stdout
{
	FILE          *log_file_ptr;
	long strl;
	unsigned char log_text[1024];
	struct tm * now = NULL;

	// get time
	time_t time_value;
	time_value = time(NULL);          // get time in seconds since 1070
	now = localtime(&time_value);     // get time and date structure

	strcpy_n(log_text, 1024, log_text_original, strlen(log_text_original));

	strl = strlen(log_text);

	if(strl>1) if(*(log_text+strl-1) == 0x0d) {*(log_text+strl-1) = 0;--strl;}
	if(strl>1) if(*(log_text+strl-1) == 0x0a) {*(log_text+strl-1) = 0;--strl;}
	if(strl>1) if(*(log_text+strl-1) == 0x0d) {*(log_text+strl-1) = 0;--strl;}
	if(strl>1) if(*(log_text+strl-1) == 0x0a) {*(log_text+strl-1) = 0;--strl;}

	log_file_ptr = fopen(FILENAME_LOGFILE, "a");  // open log file in append mode

	if(log_file_ptr == 0)
	{
		printf("WARNING !!! log_write could not write to logfile\n");
	}
	else
	{
		fprintf(log_file_ptr, "%02d.%02d.%4d %02d:%02d:%02d %s|%s\n", now->tm_mday, now->tm_mon + 1, now->tm_year + 1900, now->tm_hour, now->tm_min, now->tm_sec, global_name, log_text);
		fclose(log_file_ptr);
	}


		
	// Check if output to stdout is enabled
	if ((global_screen_output_enable == 1) && (screen_output_enable == 1))
	{
		printf("%02d:%02d:%02d %s|%s\n", now->tm_hour, now->tm_min, now->tm_sec, global_name, log_text);
	}
}



//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

void log_init(unsigned char * name, unsigned long screen_output_enable)
{
	FILE * popen_cmd;
	struct stat st;
	char rm_befehl[100];

	stat(FILENAME_LOGFILE, &st);
	if (st.st_size > FILE_LOG_MAX_SIZE)  // delete file if > 1 MB
	{
		sprintf(rm_befehl, "rm %s", FILENAME_LOGFILE);
		popen_cmd = popen(rm_befehl, "r"); // opens process by creating a pipe, forking, and invoking shell
	}

	// make name and screen_output_enable global;
	strcpy_n(global_name, sizeof(global_name), name, strlen(name));
	global_screen_output_enable = screen_output_enable;

	log_write("log_init", screen_output_enable); // output == 1 --> to stdout
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
